package net.mcreator.puzzle_code.client.gui;

import net.neoforged.neoforge.network.PacketDistributor;

import net.minecraft.world.level.Level;
import net.minecraft.world.entity.player.Player;
import net.minecraft.world.entity.player.Inventory;
import net.minecraft.resources.ResourceLocation;
import net.minecraft.network.chat.Component;
import net.minecraft.client.gui.screens.inventory.AbstractContainerScreen;
import net.minecraft.client.gui.components.WidgetSprites;
import net.minecraft.client.gui.components.ImageButton;
import net.minecraft.client.gui.components.EditBox;
import net.minecraft.client.gui.components.Button;
import net.minecraft.client.gui.GuiGraphics;
import net.minecraft.client.Minecraft;

import net.mcreator.puzzle_code.world.inventory.CustomEffectBlockGUIPowerEffectMenu;
import net.mcreator.puzzle_code.procedures.ReturnPowerEffectProcedure;
import net.mcreator.puzzle_code.network.CustomEffectBlockGUIPowerEffectButtonMessage;

import java.util.HashMap;

import com.mojang.blaze3d.systems.RenderSystem;

public class CustomEffectBlockGUIPowerEffectScreen extends AbstractContainerScreen<CustomEffectBlockGUIPowerEffectMenu> {
	private final static HashMap<String, Object> guistate = CustomEffectBlockGUIPowerEffectMenu.guistate;
	private final Level world;
	private final int x, y, z;
	private final Player entity;
	EditBox powerEffectField;
	Button button_back;
	ImageButton imagebutton_enter_button;
	ImageButton imagebutton_edit_button;

	public CustomEffectBlockGUIPowerEffectScreen(CustomEffectBlockGUIPowerEffectMenu container, Inventory inventory, Component text) {
		super(container, inventory, text);
		this.world = container.world;
		this.x = container.x;
		this.y = container.y;
		this.z = container.z;
		this.entity = container.entity;
		this.imageWidth = 176;
		this.imageHeight = 96;
	}

	private static final ResourceLocation texture = ResourceLocation.parse("puzzle_code:textures/screens/custom_effect_block_gui_power_effect.png");

	@Override
	public void render(GuiGraphics guiGraphics, int mouseX, int mouseY, float partialTicks) {
		this.renderBackground(guiGraphics, mouseX, mouseY, partialTicks);
		super.render(guiGraphics, mouseX, mouseY, partialTicks);
		powerEffectField.render(guiGraphics, mouseX, mouseY, partialTicks);
		this.renderTooltip(guiGraphics, mouseX, mouseY);
	}

	@Override
	protected void renderBg(GuiGraphics guiGraphics, float partialTicks, int gx, int gy) {
		RenderSystem.setShaderColor(1, 1, 1, 1);
		RenderSystem.enableBlend();
		RenderSystem.defaultBlendFunc();
		guiGraphics.blit(texture, this.leftPos, this.topPos, 0, 0, this.imageWidth, this.imageHeight, this.imageWidth, this.imageHeight);
		RenderSystem.disableBlend();
	}

	@Override
	public boolean keyPressed(int key, int b, int c) {
		if (key == 256) {
			this.minecraft.player.closeContainer();
			return true;
		}
		if (powerEffectField.isFocused())
			return powerEffectField.keyPressed(key, b, c);
		return super.keyPressed(key, b, c);
	}

	@Override
	public void resize(Minecraft minecraft, int width, int height) {
		String powerEffectFieldValue = powerEffectField.getValue();
		super.resize(minecraft, width, height);
		powerEffectField.setValue(powerEffectFieldValue);
	}

	@Override
	protected void renderLabels(GuiGraphics guiGraphics, int mouseX, int mouseY) {
		guiGraphics.drawString(this.font, Component.translatable("gui.puzzle_code.custom_effect_block_gui_power_effect.label_power"), 76, 5, -13421773, false);
		guiGraphics.drawString(this.font,

				ReturnPowerEffectProcedure.execute(world, x, y, z), 6, 40, -13421773, false);
		guiGraphics.drawString(this.font, Component.translatable("gui.puzzle_code.custom_effect_block_gui_power_effect.label_nbt_powereffect"), 6, 53, -13421773, false);
	}

	@Override
	public void init() {
		super.init();
		powerEffectField = new EditBox(this.font, this.leftPos + 7, this.topPos + 18, 115, 18, Component.translatable("gui.puzzle_code.custom_effect_block_gui_power_effect.powerEffectField"));
		powerEffectField.setMaxLength(32767);
		guistate.put("text:powerEffectField", powerEffectField);
		this.addWidget(this.powerEffectField);
		button_back = Button.builder(Component.translatable("gui.puzzle_code.custom_effect_block_gui_power_effect.button_back"), e -> {
			if (true) {
				PacketDistributor.sendToServer(new CustomEffectBlockGUIPowerEffectButtonMessage(0, x, y, z));
				CustomEffectBlockGUIPowerEffectButtonMessage.handleButtonAction(entity, 0, x, y, z);
			}
		}).bounds(this.leftPos + 6, this.topPos + 67, 162, 20).build();
		guistate.put("button:button_back", button_back);
		this.addRenderableWidget(button_back);
		imagebutton_enter_button = new ImageButton(this.leftPos + 150, this.topPos + 17, 20, 20,
				new WidgetSprites(ResourceLocation.parse("puzzle_code:textures/screens/enter_button.png"), ResourceLocation.parse("puzzle_code:textures/screens/enter_button_hovered.png")), e -> {
					if (true) {
						PacketDistributor.sendToServer(new CustomEffectBlockGUIPowerEffectButtonMessage(1, x, y, z));
						CustomEffectBlockGUIPowerEffectButtonMessage.handleButtonAction(entity, 1, x, y, z);
					}
				}) {
			@Override
			public void renderWidget(GuiGraphics guiGraphics, int x, int y, float partialTicks) {
				guiGraphics.blit(sprites.get(isActive(), isHoveredOrFocused()), getX(), getY(), 0, 0, width, height, width, height);
			}
		};
		guistate.put("button:imagebutton_enter_button", imagebutton_enter_button);
		this.addRenderableWidget(imagebutton_enter_button);
		imagebutton_edit_button = new ImageButton(this.leftPos + 128, this.topPos + 17, 20, 20,
				new WidgetSprites(ResourceLocation.parse("puzzle_code:textures/screens/edit_button.png"), ResourceLocation.parse("puzzle_code:textures/screens/edit_button_hovered.png")), e -> {
					if (true) {
						PacketDistributor.sendToServer(new CustomEffectBlockGUIPowerEffectButtonMessage(2, x, y, z));
						CustomEffectBlockGUIPowerEffectButtonMessage.handleButtonAction(entity, 2, x, y, z);
					}
				}) {
			@Override
			public void renderWidget(GuiGraphics guiGraphics, int x, int y, float partialTicks) {
				guiGraphics.blit(sprites.get(isActive(), isHoveredOrFocused()), getX(), getY(), 0, 0, width, height, width, height);
			}
		};
		guistate.put("button:imagebutton_edit_button", imagebutton_edit_button);
		this.addRenderableWidget(imagebutton_edit_button);
	}
}
